import { Resolver, Query, Mutation, Args } from '@nestjs/graphql';

import { <%= classify(resourceName) %>Input, <%= classify(resourceName) %> } from './model/<%= resourceName %>';
<% if (repositoryExists) { %>
import { <%= classify(resourceName) %>Repository } from './<%= resourceName %>.repository';
<% } %>
@Resolver(() => <%= classify(resourceName) %>)
export class <%= classify(resourceName) %>Resolver {
	constructor(<% if (repositoryExists) { %>private readonly <%= camelize(resourceName) %>Repository: <%= classify(resourceName) %>Repository<% } %>) {}

	@Query(() => [<%= classify(resourceName) %>])
	get<%= classify(resourceName) %>s() {
		<% if (repositoryExists) {
			%>return this.<%= camelize(resourceName) %>Repository.get<%= classify(resourceName) %>s();<%
		} else {
			%>throw new Error('Not implemented');<%
		} %>
	}

	@Query(() => <%= classify(resourceName) %>, {nullable: true})
	get<%= classify(resourceName) %>ById(@Args('id') id: string) {
		<% if (repositoryExists) {
			%>return this.<%= camelize(resourceName) %>Repository.get<%= classify(resourceName) %>ById(id);<%
		} else {
			%>throw new Error('Not implemented');<%
		} %>
	}

	@Mutation(() => <%= classify(resourceName) %>)
	save<%= classify(resourceName) %>(@Args('<%= camelize(resourceName) %>') <%= camelize(resourceName) %>: <%= classify(resourceName) %>Input) {
		<% if (repositoryExists) {
			%>return this.<%= camelize(resourceName) %>Repository.save<%= classify(resourceName) %>(<%= camelize(resourceName) %>);<%
		} else {
			%>throw new Error('Not implemented');<%
		} %>
	}

	@Mutation(() => <%= classify(resourceName) %>)
	remove<%= classify(resourceName) %>(@Args('id') id: string) {
		<% if (repositoryExists) {
			%>return this.<%= camelize(resourceName) %>Repository.remove<%= classify(resourceName) %>(id);<%
		} else {
			%>throw new Error('Not implemented');<%
		} %>
	}
}
